#ifndef __LUSB__
#define __LUSB__

#include "critical.h"

struct ILUSB_BASE
{
    //   
	virtual HANDLE __fastcall GetUSBDeviceHandle(void) = 0;
    virtual bool __fastcall OpenLDevice(BYTE VirtualSlot) = 0;   
	virtual bool __fastcall OpenLDeviceByName(LPTSTR DeviceName)=0;
    virtual bool __fastcall CloseLDevice(void) = 0;	

    virtual bool __fastcall ControlLDevice(DWORD ControlCode, _ControlRequest * CurrentRequest, BYTE DataBuffer[], DWORD DataBufferLength, DWORD Timeout)=0;
	virtual bool __fastcall CommandControl(_ControlRequest * CurrentRequest)=0;

	virtual bool __fastcall WriteBulk(BYTE DataBuffer[], DWORD DataBufferLength, DWORD * BytesWritten, DWORD Timeout)=0;
	virtual bool __fastcall ReadBulk(BYTE DataBuffer[], DWORD DataBufferLength, DWORD * BytesRead, DWORD Timeout)=0;

    virtual bool __fastcall CancelIo(void) = 0;
    //  
    virtual bool __fastcall GetModuleName(CHAR mname[], DWORD Length) = 0;
};
//-----------------------------------------------------------------------------
class TLUSB_BASE : public virtual ILUSB_BASE
{
 protected :
    TCritical cs_control;
    TCritical cs_readbulk;
    TCritical cs_writebulk;

    HINSTANCE hInstance;                  //   DLL
    HANDLE hDevice;                       //      
	OVERLAPPED ControlOverlapped, ReadBulkOverlapped, WriteBulkOverlapped;	
    //
 public :
    // /
    TLUSB_BASE(unsigned int ioctl_retries);
    virtual ~TLUSB_BASE(void);

	int LastErrorNumber;                 //   
    unsigned int MaxIoctlRetries;
    unsigned int LastIoctlRetries;

    //   
	virtual HANDLE __fastcall GetUSBDeviceHandle(void) { return hDevice; }
	virtual bool __fastcall OpenLDevice(BYTE VirtualSlot);
	virtual bool __fastcall OpenLDeviceByName(LPTSTR DeviceName);
    virtual bool __fastcall CloseLDevice(void);
    
	virtual bool __fastcall ControlLDevice(DWORD ControlCode, _ControlRequest * CurrentRequest, BYTE DataBuffer[], DWORD DataBufferLength, DWORD Timeout);
	virtual bool __fastcall CommandControl(_ControlRequest * CurrentRequest);

	virtual bool __fastcall WriteBulk(BYTE DataBuffer[], DWORD DataBufferLength, DWORD * BytesWritten, DWORD Timeout);
	virtual bool __fastcall ReadBulk(BYTE DataBuffer[], DWORD DataBufferLength, DWORD * BytesRead, DWORD Timeout);

    virtual bool __fastcall CancelIo(void);
    //  
    virtual bool __fastcall GetModuleName(CHAR mname[], DWORD Length);
};

#endif
