//$$---- Form CPP ----
//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop
#include "usb_util.h"
#include "Unit1.h"
#include "DialogAddIP.h"
#include "CenterMsgBox.h"
#include "stringres.h"
#include <dbt.h>
#include <devguid.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

static bool f_first_run = true;
bool g_bNoTrayIcon = false;
TFormMAIN *FormMAIN;

/*   StringGridIPCrates */
enum
    {
    EGRID_COL_NUMBER = 0,
    EGRID_COL_IPAUTO,
    EGRID_COL_IPTYPE,
    EGRID_COL_IPADDR,
    EGRID_COL_STATUS,
    EGRID_COL_SERIAL
    };

/*  */
static const struct
    {
    LANGID langid;
    const char *ConfigStr;      /*    ini- */
    }
    LanguageInfo[] =
    {
    { 0, "auto" },
    { MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US), "en" },
    { MAKELANGID(LANG_RUSSIAN, SUBLANG_DEFAULT), "ru" }
    };

/*      StringGridIPCrates */
AnsiString SC_STAT_OFFLINE;
AnsiString SC_STAT_CONNECTING;
AnsiString SC_STAT_ONLINE;
AnsiString SC_STAT_ERROR;
AnsiString SC_TYPE_STATIC;
AnsiString SC_TYPE_DYNAMIC;
AnsiString SC_Tooltip_Auto;
AnsiString SC_Tooltip_Status;
AnsiString SC_Tooltip_Type[2];
const AnsiString SC_AUTO_ON = "a"; /*    Marlett */
const AnsiString SC_AUTO_OFF = "";

//---------------------------------------------------------------------------
#define SENDER(var, type)   \
    type* var = dynamic_cast<type*>(Sender); \
    if (!var) return;
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TFormMAIN::TFormMAIN(TComponent* Owner) : TForm(Owner),
    ltrservicecrate(NULL), init_ok(false), TrayIcon(NULL)
    {
    if (!g_bNoTrayIcon)
        {
        try
            {
            TrayIcon = new TTrayIcon(this);
            TrayIcon->OnClick = TrayIcon1Click;
            TrayIcon->Visible = true;
            //      TTrayIcon  
            // PopupMenu.   OnMouseDown    Popup.
            //TrayIcon->PopupMenu = TrayPopupMenu;
            TrayIcon->OnMouseDown = TrayIcon1MouseDown;
            }
        catch (...)
            { //    , ,    srvany
            TrayIcon = NULL;
            }
        }

    CrateTreeTags = new TStringList;
    log_list->Clear();
    Statistic->Clear();
    }

//---------------------------------------------------------------------------
__fastcall TFormMAIN::~TFormMAIN()
    {
    delete CrateTreeTags;
    if (TrayIcon) delete TrayIcon;
    }

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::StringGridIPCratesDrawCell(TObject *Sender, int ACol, int ARow,
      TRect &Rect, TGridDrawState State)
    {
    SENDER(Grid, TStringGrid);
    AnsiString Value = Grid->Cells[ACol][ARow];
    RECT TextRect = static_cast<RECT>(Rect);
    unsigned int align = DT_LEFT;

    switch (ACol)
        {
        case EGRID_COL_NUMBER:
            align = DT_CENTER;
            break;
        case EGRID_COL_IPAUTO:
            align = DT_CENTER;
            if (ARow > 0)
                {
                Grid->Canvas->Font->Name = "Marlett";
                Grid->Canvas->Font->Height *= 2;
                }
            break;
        }
    Grid->Canvas->FillRect(Rect);
    InflateRect(&TextRect, -2, -2);
    DrawText(Grid->Canvas->Handle, Value.c_str(), Value.Length(), &TextRect,
        DT_SINGLELINE | DT_VCENTER | align);
    }

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::SetIcon(en_IconID id)
    {
    Application->Icon->ReleaseHandle();
    Application->Icon->Handle = IconSet.AppIcon[id];
    if (TrayIcon)
        {
        TrayIcon->Icon->ReleaseHandle();
        TrayIcon->Icon->Handle = IconSet.TrayIcon[id];
        TrayIcon->Refresh();
        }
    IconSet.CurrentId = id;
    }

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::Dispatch(void *_msg)
    {
    TMessage *msg = (TMessage*)_msg;
    PDEV_BROADCAST_DEVICEINTERFACE pDevIface;
    switch (msg->Msg)
        {
        case WM_DEVICECHANGE:
            /*     USB  */
            switch (msg->WParam)
                {
#if USB_DETECT_ADVANCED
                case DBT_DEVICEARRIVAL:
                case DBT_DEVICEREMOVECOMPLETE:
                    pDevIface = (PDEV_BROADCAST_DEVICEINTERFACE)msg->LParam;
                    if (DBT_DEVTYP_DEVICEINTERFACE == pDevIface->dbcc_devicetype)
                        {
                        const char* dev_path = (const char*)pDevIface->dbcc_name;
                        const char* verb =
                            (DBT_DEVICEARRIVAL == msg->WParam) ? "connected" : "disconnected";
                        AnsiString errstr;
                        AnsiString desc;
                        DWORD DevInst;

                        if (!USB_GetDeviceInfoByPath(dev_path, &desc, &DevInst, errstr))
                            {
                            LOGWRITE(Format("Cannot process %s USB device %s: %s",
                                ARRAYOFCONST((verb, dev_path, errstr))),
                                LOGTASK_GLOBAL, LOGL_ERROR);
                            }
                        else if (USB_IsKnownDeviceName(dev_path))
                            {
                            if (g_Log.CheckLevel(LOGL_DEBUG1))
                                {
                                LOGWRITE(Format("USB crate %s: \"%s\" at %s", ARRAYOFCONST((verb, desc, dev_path))),
                                    LOGTASK_GLOBAL, LOGL_INFO);
                                }
                            else
                                {
                                LOGWRITE(Format("USB crate %s: \"%s\"", ARRAYOFCONST((verb, desc))),
                                    LOGTASK_GLOBAL, LOGL_INFO);
                                }
                            if (ltrservicecrate)
                                ltrservicecrate->PostControlMessage(MsgControl(
                                    (DBT_DEVICEARRIVAL == msg->WParam) ? LTR_SRV_insert_usb : LTR_SRV_remove_usb,
                                    DevInst));
                            }
                        else
                            {
                            LOGWRITE(Format("USB device %s, unsupported: \"%s\" at %s",
                                ARRAYOFCONST((verb, desc, dev_path))),
                                LOGTASK_GLOBAL, LOGL_DEBUG3);
                            }
                        }
                    break;
#else
                case DBT_DEVNODES_CHANGED:
                    if (ltrservicecrate)
                        ltrservicecrate->PostControlMessage(LTR_SRV_rescan_usb);
                    break;
#endif
                }
            break;
        case WM_SYSCOMMAND:
            switch (msg->WParam)
                {
                case SC_MINIMIZE:
                    Application->Minimize();
                    if (TrayIcon && MenuSettingsMinimizeToTray->Checked)
                        ShowWindow(Application->Handle, SW_HIDE);
                    break;
                }
            break;
        case WM_POWERBROADCAST:
            if (ltrservicecrate)
                {
                switch (msg->WParam)
                    {
                    case PBT_APMSUSPEND:
                    case PBT_APMQUERYSUSPEND:
                        ltrservicecrate->PostControlMessage(LTR_SRV_suspend);
                        break;
                    case PBT_APMRESUMEAUTOMATIC:
                    case PBT_APMRESUMECRITICAL:
                    case PBT_APMRESUMESUSPEND:
                        ltrservicecrate->PostControlMessage(LTR_SRV_resume_suspend);
                        break;
                    }
                }
            break;
        case WM_APP_RESTART:
            Restart();
            break;
        }
    TForm::Dispatch(_msg);
    }

//---------------------------------------------------------------------------
__fastcall TUpdateInfoThread::TUpdateInfoThread(TFormMAIN *ParentForm)
    : TThread(true)
    {
    Form = ParentForm;
    ZeroMemory(&Stats, sizeof(Stats));
    Stats.reset = true;

    SC_CRATE_TITLE_FORMAT = "CSN <%.16s> - %s";
    SC_empty = LoadStr(IDS_empty);
    SC_Initialization = LoadStr(IDS_Initialization);
    SC_unknown_interface = LoadStr(IDS_unknown_interface);
    SC_Unknown_Crate = LoadStr(IDS_Unknown_Crate);
    SC_boot_loader = LoadStr(IDS_boot_loader);
    SC_state_error = LoadStr(IDS_state_error);
    SC_state_ok = LoadStr(IDS_state_ok);
    SC_Bad_Module_Name = LoadStr(IDS_Bad_Module_Name);

    SC_Crate_statistics_for = LoadStr(IDS_Crate_statistics_for);
    SC_Crate_serial_number = LoadStr(IDS_Crate_serial_number);
    SC_Interface = LoadStr(IDS_Interface);
    SC_Connected = LoadStr(IDS_Connected);
    SC_HwRevision = LoadStr(IDS_HwRevision);
    SC_Total_sent_words = LoadStr(IDS_Total_sent_words);
    SC_Total_recv_words = LoadStr(IDS_Total_recv_words);
    SC_Data_input_speed = LoadStr(IDS_Data_input_speed);
    SC_Data_output_speed = LoadStr(IDS_Data_output_speed);
    SC_words_per_second = LoadStr(IDS_words_per_second);
    SC_Start_marks_received = LoadStr(IDS_Start_marks_received);
    SC_Second_marks_received = LoadStr(IDS_Second_marks_received);
    SC_Statistics_for_slot = LoadStr(IDS_Statistics_for_slot);
    SC_Status = LoadStr(IDS_Status);
    SC_No_module = LoadStr(IDS_No_module);
    SC_Identifying_module = LoadStr(IDS_Identifying_module);
    SC_Contains_module = LoadStr(IDS_Contains_module);
    SC_Num_sent_words = LoadStr(IDS_Num_sent_words);
    SC_Num_recv_words = LoadStr(IDS_Num_recv_words);
    SC_Server_buffer_util = LoadStr(IDS_Server_buffer_util);
    SC_Connected_clients = LoadStr(IDS_Connected_clients);
    SC_Hardware_FIFO_state = LoadStr(IDS_Hardware_FIFO_state);
    Resume();
    }

//---------------------------------------------------------------------------
void __fastcall TUpdateInfoThread::UpdateCrateList(void)
    {
    TFormMAIN::en_IconID icon_id = TFormMAIN::icoNoCrates;

    if (WaitForSingleObject(crate_list_access, 500) != WAIT_OBJECT_0)
        return;

    Form->CrateTree->Items->BeginUpdate();
    Form->CrateTree->Items->Clear();
    Form->CrateTreeTags->Clear();
    for (int i = 0; i < CRATE_MAX; i++)
        {
        if (crate_list[i]->GetState() != CRATE_ST_ONLINE)
            continue;

        TCrate *crate=crate_list[i];
        TTreeNode *node;

        int tag_idx = Form->CrateTreeTags->Add(crate->path);
        if (crate->sflags & CRATE_FLAG_BOOT_LOADER)
            {
            node = Form->CrateTree->Items->AddObject(NULL, Format(SC_CRATE_TITLE_FORMAT,
                ARRAYOFCONST((crate->csn, SC_boot_loader))), (void*)tag_idx);
            }
        else
            {
            node = Form->CrateTree->Items->AddObject(NULL, Format(SC_CRATE_TITLE_FORMAT,
                ARRAYOFCONST((crate->csn,
                    (crate->sflags & CRATE_FLAG_HW_ERROR) ? SC_state_error : SC_state_ok))),
                    (void*)tag_idx);

            for (int j = 0; j < MODULE_MAX; j++)
                {
                WORD mid;
                if (crate->Module[j].GetMID(mid) != TCrateModule::eOk)
                    mid = 0;
                AnsiString astr=Format("<slot%0.2d%s> - ", ARRAYOFCONST((j+1, (crate->baud_rate&(1<<j)) ? "+" : " ")));

                if (!mid)
                    {
                    astr += SC_empty;
                    }
                else if (mid == 0xFFFF)
                    {
                    astr += SC_Initialization;
                    }
                else
                    {
                    if ((mid & 0xFF) != ((mid >> 8) & 0xFF))
                        astr += SC_Bad_Module_Name;
                    else
                        astr += Format("mid = %d ", ARRAYOFCONST(((int)mid & 0xFF)));
                    }
                Form->CrateTree->Items->AddChild(node, astr);
                }
            }
        node->Expand(true);

        if (TFormMAIN::icoCrateError != icon_id)
            icon_id = (crate->sflags & CRATE_FLAG_HW_ERROR)
                ? TFormMAIN::icoCrateError : TFormMAIN::icoCrateOk;
        } /* for i */

    Form->CrateTree->Items->EndUpdate();

    ReleaseMutex(crate_list_access);

    if (icon_id != Form->IconSet.CurrentId)
        Form->SetIcon(icon_id);
    }

//---------------------------------------------------------------------------
void __fastcall TUpdateInfoThread::UpdateIPList(void)
    {
    /*  Grid     IP- */
    const int ListType[] = { IPLIST_STATIC, IPLIST_DYNAMIC };
    const AnsiString *const ListName[] = { &SC_TYPE_STATIC, &SC_TYPE_DYNAMIC };
    int num_rows = 0;

    if (!Form->ltrservicecrate) return;

    for (int type = 0; type < sizeof(ListType) / sizeof(ListType[0]); type++)
        {
        TAddrList *IPList =
            IPCrateList.ExportList(ListType[type]);
        if (!IPList) continue;
        TAddrListNode *addr = IPList->GetFirstNode();
        while (addr)
            {
            num_rows++;
            TStrings *Row = Form->StringGridIPCrates->Rows[num_rows];
            AnsiString CrateStatus;
            switch (addr->iStatus)
                {
                case IP_STATUS_OFFLINE:
                    CrateStatus = SC_STAT_OFFLINE;
                    break;
                case IP_STATUS_CONNECTING:
                    CrateStatus = SC_STAT_CONNECTING;
                    break;
                case IP_STATUS_ONLINE:
                    CrateStatus = SC_STAT_ONLINE;
                    break;
                default:
                    CrateStatus = SC_STAT_ERROR;
                    break;
                }
            Row->BeginUpdate();
            Row->Strings[EGRID_COL_NUMBER] = AnsiString(num_rows);
            Row->Strings[EGRID_COL_IPTYPE] = *ListName[type];
            Row->Strings[EGRID_COL_IPAUTO] = (addr->dwFlags & CRATE_IP_FLAG_AUTOCONNECT) ?
                SC_AUTO_ON : SC_AUTO_OFF;
            Row->Strings[EGRID_COL_IPADDR] = IPToStr(addr->dwIP);
            Row->Strings[EGRID_COL_STATUS] = CrateStatus;
            Row->Strings[EGRID_COL_SERIAL] = addr->szSerial;
            Row->EndUpdate();
            addr = addr->next;
            }
        delete IPList;
        } /* for type */
    /*   ,    ,    grid */
    if (num_rows == 0)
        Form->StringGridIPCrates->Rows[++num_rows]->Clear();
    Form->StringGridIPCrates->RowCount = 1 + num_rows;
    }

//---------------------------------------------------------------------------
void __fastcall TUpdateInfoThread::UpdateStatistics(void)
    {
    if (WaitForSingleObject(crate_list_access, 500) != WAIT_OBJECT_0)
        return;
    //     
    Form->Statistic->Lines->BeginUpdate();
    Form->Statistic->Clear();

    if (Form->CrateTree->Selected &&
        (WaitForSingleObject(client_list_access, 500) == WAIT_OBJECT_0))
        {
        TTreeNode *node = Form->CrateTree->Selected;
        if (node->Level)
            {
            int i = node->Text.AnsiPos("<");
            int j = node->Text.AnsiPos(">");
            Stats.slot = node->Text.SubString(i+5, j-i-6).ToInt();
            node=node->Parent;
            }
        else
            {
            Stats.slot = 0;
            }
        AnsiString node_tag = Form->CrateTreeTags->Strings[(int)node->Data];

        if (strncmp(Stats.path, node_tag.c_str(), sizeof(Stats.path)))
            { /*     ,  */
            STRNCPYZ(Stats.path, node_tag.c_str());
            Stats.reset = true;
            }

        //    
        for (int i = 0; i < CRATE_MAX; i++)
            {
            TCrate *crate = crate_list[i];

            if (!crate || strncmp(crate->path, Stats.path, sizeof(crate->path)))
                continue;

            AnsiString CrateTypeStr = "";
            AnsiString CrateConnectionInfo = "";
            AnsiString CrateVersionStr = "";
            switch (crate->CrateType)
                {
                case CRATE_TYPE_LTR010:
                    CrateTypeStr = "LTR-U-8/LTR-U-16";
                    break;
                case CRATE_TYPE_LTR021:
                    CrateTypeStr = "LTR-U-1";
                    break;
                case CRATE_TYPE_LTR030:
                    CrateTypeStr = "LTR-EU-8/LTR-EU-16";
                    CrateVersionStr = IntToStr(crate->hw_revision);
                    break;
                case CRATE_TYPE_LTR031:
                    CrateTypeStr = "LTR-EU-2";
                    CrateVersionStr = IntToStr(crate->hw_revision);
                    break;
                case CRATE_TYPE_LTR032:
                    CrateTypeStr = "LTR-E-7/LTR-E-15";
                    CrateVersionStr = IntToStr(crate->hw_revision);
                    break;
                default:
                    CrateTypeStr = SC_Unknown_Crate;
                    break;
                }

            switch (crate->GetConnType())
                {
                case CRATE_IFACE_TCPIP:
                    CrateConnectionInfo = "TCP/IP, " + AnsiString(crate->path);
                    break;
                case CRATE_IFACE_USB:
                    CrateConnectionInfo = USB_ConnInfoString(crate->usb_info);
                    break;
                default:
                    CrateConnectionInfo = SC_unknown_interface;
                    break;
                }
            Form->Statistic->Lines->Add("------ " + SC_Crate_statistics_for + " " + CrateTypeStr + " ------");
            Form->Statistic->Lines->Add(Format(SC_Crate_serial_number + " : %.16s", ARRAYOFCONST((crate->csn))));
            if (!CrateVersionStr.IsEmpty())
                Form->Statistic->Lines->Add(SC_HwRevision + ": " + CrateVersionStr);
            Form->Statistic->Lines->Add(SC_Interface + ": " + CrateConnectionInfo);
            Form->Statistic->Lines->Add(SC_Connected + ": " + DateTimeToStr(SystemTimeToDateTime(crate->start_time), Form->LocaleFormatSettings));
            Form->Statistic->Lines->Add(SC_Total_recv_words + ": " + IntToStr(crate->total_count_recv));
            Form->Statistic->Lines->Add(SC_Total_sent_words + ": " + IntToStr(crate->total_count_send));
            if (!Stats.reset)
                {
                DWORD tick_count = GetTickCount() - Stats.tick_count;
                if (tick_count == 0)
                    tick_count = 1;
                double current_speed_recv = 1000.0 * (crate->total_count_recv - Stats.count_recv) / tick_count;
                double current_speed_send = 1000.0 * (crate->total_count_send - Stats.count_send) / tick_count;
                Form->Statistic->Lines->Add(SC_Data_input_speed + Format(": %.1f ", ARRAYOFCONST((current_speed_recv))) + SC_words_per_second);
                Form->Statistic->Lines->Add(SC_Data_output_speed + Format(": %.1f ", ARRAYOFCONST((current_speed_send))) + SC_words_per_second);
                }
            else
                {
                Stats.reset = false;
                }
            Stats.count_recv = crate->total_count_recv;
            Stats.count_send = crate->total_count_send;

            Form->Statistic->Lines->Add(SC_Start_marks_received + Format(": %d", ARRAYOFCONST(((int)crate->start_mark_counter))));
            Form->Statistic->Lines->Add(SC_Second_marks_received + Format(": %d", ARRAYOFCONST(((int)crate->second_mark_counter))));
            if (Stats.slot)
                {
                TCrateModule::stat_t stat;
                Form->Statistic->Lines->Add("");
                Form->Statistic->Lines->Add(Format("----- " + SC_Statistics_for_slot + " %0.2d -----", ARRAYOFCONST((Stats.slot))));
                AnsiString astr = SC_Status + "  : ";
                if (crate->Module[Stats.slot - 1].GetStatistics(stat) != TCrateModule::eOk)
                    {
                    astr += SC_No_module;
                    Form->Statistic->Lines->Add(astr);
                    }
                else
                    {
                    if (!stat.mid)
                        {
                        astr += SC_No_module;
                        Form->Statistic->Lines->Add(astr);
                        }
                    else if ((stat.mid == 0xFFFF) || (stat.mid & 0xFF) != ((stat.mid >> 8) & 0xFF))
                        {
                        astr += SC_Identifying_module;
                        Form->Statistic->Lines->Add(astr);
                        }
                    else
                        {
                        astr += SC_Contains_module + Format(" LTR%d ", ARRAYOFCONST(((int)stat.mid & 0xFF)));
                        Form->Statistic->Lines->Add(astr);
                        Form->Statistic->Lines->Add(SC_Num_recv_words + ": " + IntToStr(stat.count_recv));
                        Form->Statistic->Lines->Add(SC_Num_sent_words + ": " + IntToStr(stat.count_send));
                        Form->Statistic->Lines->Add("");
                        __int64 NumDataClient = 0;
                        int ClientCount = 0;
                        for (int client = 0; client < CLIENT_MAX; client++)
                            {
                            if (client_list[client] && (client_list[client]->pcrate == crate)
                               && (client_list[client]->crate_channel == Stats.slot)
                               && client_list[client]->IsOpen())
                                {
                                NumDataClient = std::max(client_list[client]->read_rec.last_count, NumDataClient);
                                ClientCount++;
                                }
                            }

                        double NumData = stat.count_FIFO_recv - NumDataClient;
                        double Percent = 0;
                        if ((NumData > 0) && (ClientCount > 0))
                            {
                            Percent = std::min(NumData * 100.0 / TCrateModule::RecvBufLen, 100.0);
                            }
                        Form->Statistic->Lines->Add(SC_Server_buffer_util + Format(" : %0.2f", ARRAYOFCONST(((double)Percent)))+" %");
                        Form->Statistic->Lines->Add(SC_Connected_clients + " : " + IntToStr(ClientCount));

                        if (stat.mid == LTR_MID(34))
                            {
                            Form->Statistic->Lines->Add("");
                            Form->Statistic->Lines->Add(SC_Hardware_FIFO_state + Format(": %0.6X", ARRAYOFCONST(((int)stat.fifo_len))));
                            }
                        }
                    }
                }
            else /* !statistic_slot */
                {
                int ClientCount = 0;
                for (int client = 0; client < CLIENT_MAX; client++)
                    {
                    if (client_list[client] && client_list[client]->IsOpen() &&
                       (client_list[client]->pcrate == crate))
                        {
                        ClientCount++;
                        }
                    }
                Form->Statistic->Lines->Add("");
                Form->Statistic->Lines->Add(SC_Connected_clients + " : " + IntToStr(ClientCount));
                }

            break;
            }
        Stats.tick_count = GetTickCount();
        ReleaseMutex(client_list_access);
        }

    Form->Statistic->Lines->EndUpdate();
    ReleaseMutex(crate_list_access);
    }

//---------------------------------------------------------------------------
void __fastcall TUpdateInfoThread::UpdateLog(void)
    {
    g_Log.Flush(Form->log_list->Lines, SCREEN_LOG_SIZE);
    }

//---------------------------------------------------------------------------
void __fastcall TUpdateInfoThread::UpdateVars(void)
    {
    //   ,    
    bool prio_high =
        (PriorityRank(GetPriorityClass(GetCurrentProcess())) > PRIORANK_NORMAL);
    Form->TrayPopupHighPriority->Checked = prio_high;
    Form->MenuSettingsHighPriority->Checked = prio_high;
    Form->MenuSettingsAD_autoconnect->Checked = g_Conf.AutoConnectDynamic();
    Form->MenuSettingsAD_enable->Checked = g_Conf.EnableAutoDiscovery();
    Form->LogLevelMenuItemList[g_Conf.LogLevel()]->Checked = true;
    }

//---------------------------------------------------------------------------
__fastcall TUpdateInfoThread::~TUpdateInfoThread(void)
    {
    }

//---------------------------------------------------------------------------
void __fastcall TUpdateInfoThread::Execute(void)
    {
    MsgDisplay CurrMessage;
    DWORD msg_count = 0;

    /*   */
    while (!Terminated)
        {
        if (Form->MQ_Display.get(&CurrMessage, 500))
            {
            msg_count++;
            switch (CurrMessage.dwMessage)
                {
                case LTR_DISP_crate_list_updated:
                    //   
                    Synchronize((TThreadMethod)&UpdateCrateList);
                    break;
                case LTR_DISP_ip_list_updated:
                    Synchronize((TThreadMethod)&UpdateIPList);
                    break;
                case LTR_DISP_gui_vars_updated:
                    //   GUI,    
                    Synchronize((TThreadMethod)&UpdateVars);
                    break;
                case LTR_DISP_request_restart:
                    //    
                    PostMessage(Form->Handle, WM_APP_RESTART, 0, 0);
                    break;
                case LTR_DISP_request_shutdown:
                    //    
                    PostMessage(Form->Handle, WM_CLOSE, 0, 0);
                    break;
                }
            } /* if PopMessage */
        else
            {
            msg_count = 0;
            // GUI   ..   
            Synchronize((TThreadMethod)&UpdateVars);
            } /* if PopMessage */

        /*    ,     */
        if (msg_count < 2)
            {
            /*   */
            Synchronize((TThreadMethod)&UpdateStatistics);

            /*   */
            Synchronize((TThreadMethod)&UpdateLog);
            }
        } /* while (!Terminated) */
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::AppMinimize(TObject *Sender)
    {
    TrayPopupRestore->Visible = true;
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::AppRestore(TObject *Sender)
    {
    TrayPopupRestore->Visible = false;
    }
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void __fastcall TFormMAIN::SetLanguage(LANGID langid)
    {
    LCID lcid = (langid)
        ? MAKELCID(langid, SORT_DEFAULT)
        : GetUserDefaultLCID();

    langid = LANGIDFROMLCID(lcid);

    /*  Windows 2000/XP  SetThreadLocale().  Vista     ,
         SetThreadUILanguage(), ,   ,   kernel32 
        */
    if (LOBYTE(LOWORD(GetVersion())) > 5)
        { /* Vista */
        typedef LANGID (WINAPI *tSetThreadUILanguage)(LANGID);
        tSetThreadUILanguage pSetThreadUILanguage =
            (tSetThreadUILanguage)
            GetProcAddress(GetModuleHandle("kernel32.dll"), "SetThreadUILanguage");
        if (pSetThreadUILanguage)
            {
            pSetThreadUILanguage(langid);
            }
        else
            {
            SetThreadLocale(lcid);
            }
        }
    else
        { /* 2K/XP */
        SetThreadLocale(lcid);
        }

    CurrentLangID = langid;

    /*   /,      */
    GetLocaleFormatSettings(lcid, LocaleFormatSettings);
    switch (PRIMARYLANGID(langid))
        {
        case LANG_RUSSIAN:
            LocaleFormatSettings.ShortDateFormat = "dd.MM.yyyy";
            break;
        case LANG_ENGLISH:
            LocaleFormatSettings.ShortDateFormat = "MMM dd, yyyy";
            break;
        }
    /*    -, AM/PM -   */
    LocaleFormatSettings.LongTimeFormat = "hh:mm:ss";
    }

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::FormCreate(TObject *Sender)
    {
    crate_list_access = CreateMutex(NULL, FALSE, NULL);
    client_list_access = CreateMutex(NULL, FALSE, NULL);
    // ZeroMemory(client_list, sizeof(client_list));
    // ZeroMemory(crate_list, sizeof(crate_list));

    g_Conf.SetMaxLogLevel(sizeof(LogLevelMenuItemList)/sizeof(LogLevelMenuItemList[0]) - 1);
    g_Conf.Open();

    /*   */
    int LangSel = 0;
    AnsiString lang = AnsiLowerCase(g_Conf.Language());

    for (int i = 0; i < sizeof(LanguageInfo)/sizeof(LanguageInfo[0]); i++)
        {
        if (lang == LanguageInfo[i].ConfigStr)
            {
            LangSel = i;
            break;
            }
        }

    /*   ,      LoadStr() */
    SetLanguage(LanguageInfo[LangSel].langid);

    Application->OnMinimize = AppMinimize;
    Application->OnRestore = AppRestore;

    /*       */
    SC_STAT_OFFLINE = LoadStr(IDS_CSTAT_OFFLINE);
    SC_STAT_CONNECTING = LoadStr(IDS_CSTAT_CONNECTING);
    SC_STAT_ONLINE = LoadStr(IDS_CSTAT_ONLINE);
    SC_STAT_ERROR = LoadStr(IDS_CSTAT_ERROR);
    SC_TYPE_STATIC = LoadStr(IDS_CTYPE_STATIC);
    SC_TYPE_DYNAMIC = LoadStr(IDS_CTYPE_DYNAMIC);

    SC_Tooltip_Auto = LoadStr(IDS_tt_Auto);
    SC_Tooltip_Status = LoadStr(IDS_tt_Status);
    SC_Tooltip_Type[0] = LoadStr(IDS_tt_TypeStatic);
    SC_Tooltip_Type[1] = LoadStr(IDS_tt_TypeDynamic);

    TabSheetCrateList->Caption = LoadStr(IDS_tabcap_Crates);
    GroupBoxStat->Caption = " " + LoadStr(IDS_grpcap_Statistics) + " ";
    GroupBoxTree->Caption = " " + LoadStr(IDS_grpcap_CrateList) + " ";
    TabSheetIPCrates->Caption = LoadStr(IDS_tabcap_IPCrateCtl);
    TabSheetLog->Caption = LoadStr(IDS_tabcap_Log);

    MenuFile->Caption = LoadStr(IDS_menu_File);
    MenuFileRestart->Caption = LoadStr(IDS_mi_RestartServer);
    MenuFileExit->Caption = LoadStr(IDS_mi_Shutdown);

    MenuSettings->Caption = LoadStr(IDS_menu_Settings);
    MenuSettingsLang->Caption = LoadStr(IDS_subm_SettingsLanguage);
    MenuSettingsLang_auto->Caption = LoadStr(IDS_mi_SettingsLanguageAuto);
    MenuSettingsLang_en->Caption = LoadStr(IDS_mi_SettingsLanguageEN);
    MenuSettingsLang_ru->Caption = LoadStr(IDS_mi_SettingsLanguageRU);
    MenuSettingsHighPriority->Caption = LoadStr(IDS_mi_SettingsHighPriority);
    MenuSettingsStartMinimized->Caption = LoadStr(IDS_mi_SettingsStartMin);
    MenuSettingsMinimizeToTray->Caption = LoadStr(IDS_mi_SettingsMinToTray);
    MenuSettingsAD_enable->Caption = LoadStr(IDS_mi_SettingsADEnable);
    MenuSettingsAD_autoconnect->Caption = LoadStr(IDS_mi_SettingsADAutoConn);

    MenuLogLevel->Caption = LoadStr(IDS_subm_LogLevel);
    MenuLogLevel_0->Caption = LoadStr(IDS_mi_LogLevel0);
    MenuLogLevel_1->Caption = LoadStr(IDS_mi_LogLevel1);
    MenuLogLevel_2->Caption = LoadStr(IDS_mi_LogLevel2);
    MenuLogLevel_3->Caption = LoadStr(IDS_mi_LogLevel3);
    MenuLogLevel_4->Caption = LoadStr(IDS_mi_LogLevel4);
    MenuLogLevel_5->Caption = LoadStr(IDS_mi_LogLevel5);
    MenuLogLevel_6->Caption = LoadStr(IDS_mi_LogLevel6);
    MenuLogLevel_7->Caption = LoadStr(IDS_mi_LogLevel7);

    PopupConnectCrate->Caption = LoadStr(IDS_mi_ConnectIP);
    PopupDisconnectCrate->Caption = LoadStr(IDS_mi_DisconnectIP);
    PopupDeleteCrateIP->Caption = LoadStr(IDS_mi_DeleteAddressIP);
    PopupEditCrateIP->Caption = LoadStr(IDS_mi_ChangeAddressIP);
    PopupAutoConnectIPToggle->Caption = LoadStr(IDS_mi_ConnectIPAtStart);
    PopupConnectAllIP->Caption = LoadStr(IDS_mi_ConnectAllAuto);
    PopupDisconnectAllIP->Caption = LoadStr(IDS_mi_DisconnectAllCrates);
    PopupAddCrateIP->Caption = LoadStr(IDS_mi_AddIPAddress);
    LogPopupClear->Caption = LoadStr(IDS_mi_ClearLog);
    TrayPopupRestore->Caption = LoadStr(IDS_mi_Restore);
    TrayPopupRestart->Caption = LoadStr(IDS_mi_RestartServer);
    TrayPopupHighPriority->Caption = LoadStr(IDS_mi_SettingsHighPriority);
    TrayPopupShutdown->Caption = LoadStr(IDS_mi_Shutdown);

    /*    */
    MenuCaption.Connect = PopupConnectCrate->Caption;
    MenuCaption.Disconnect = PopupDisconnectCrate->Caption;
    MenuCaption.Delete = PopupDeleteCrateIP->Caption;
    MenuCaption.Edit = PopupEditCrateIP->Caption;
    MenuCaption.AutoConnect = PopupAutoConnectIPToggle->Caption;

    LogLevelMenuItemList[0] = MenuLogLevel_0;
    LogLevelMenuItemList[1] = MenuLogLevel_1;
    LogLevelMenuItemList[2] = MenuLogLevel_2;
    LogLevelMenuItemList[3] = MenuLogLevel_3;
    LogLevelMenuItemList[4] = MenuLogLevel_4;
    LogLevelMenuItemList[5] = MenuLogLevel_5;
    LogLevelMenuItemList[6] = MenuLogLevel_6;
    LogLevelMenuItemList[7] = MenuLogLevel_7;

    LangMenuItemList[0] = MenuSettingsLang_auto;
    LangMenuItemList[1] = MenuSettingsLang_en;
    LangMenuItemList[2] = MenuSettingsLang_ru;

    /*   IP  */
    StringGridIPCrates->RowCount = 2;
    StringGridIPCrates->Cells[EGRID_COL_NUMBER][0] = LoadStr(IDS_NUMBER_SIGN);
    StringGridIPCrates->Cells[EGRID_COL_IPTYPE][0] = LoadStr(IDS_Type);
    StringGridIPCrates->Cells[EGRID_COL_IPAUTO][0] = LoadStr(IDS_Auto);
    StringGridIPCrates->Cells[EGRID_COL_IPADDR][0] = LoadStr(IDS_IP);
    StringGridIPCrates->Cells[EGRID_COL_STATUS][0] = LoadStr(IDS_Status);
    StringGridIPCrates->Cells[EGRID_COL_SERIAL][0] = LoadStr(IDS_Serial_N);
    StringGridIPCrates->Rows[1]->Clear();
    IPGridColWidth[0] = 68;
    IPGridColWidth[1] = 68;
    IPGridColWidth[2] = 114;
    IPGridColWidth[3] = 228;
    IPGridColWidth[4] = 183;
    IPGridColWidth[5] = 0;
    {
    AnsiString GridParamStr = LoadStr(IDS_GRIDPARAMS) + ",";
    int i = 0;
    while (1)
        {
        int elem;
        int commapos = GridParamStr.AnsiPos(",");
        if (!commapos)
            break;
        if (!TryStrToInt(GridParamStr.SubString(1, commapos - 1).Trim(), elem))
            elem = 0;
        if (elem > 1000)
            elem = 0;
        GridParamStr.Delete(1, commapos);
        IPGridColWidth[i++] = elem;
        if (elem == 0)
            break;
        if (i >= sizeof(IPGridColWidth)/sizeof(IPGridColWidth[0]))
            break;
        }
    }
    PageControl1Resize(PageControl1); /*    */

    /*   */
    if (f_first_run)
    {
    WINDOWPLACEMENT wp;
    wp.length = sizeof(wp);
    GetWindowPlacement(Handle, &wp);
    TLtrConfig::VisualState vs;
    g_Conf.LoadVisualState(vs);

    if (vs.valid)
        wp.rcNormalPosition = vs.rect;

    if (g_Conf.StartMinimized())
        { // start minimized
        TrayPopupRestore->Visible = true;
        if (g_Conf.MinimizeToTray() && TrayIcon)
            {
            //ShowWindow(Application->Handle, SW_HIDE);
            wp.showCmd = SW_HIDE;
            Application->ShowMainForm = false;
            }
        else
            {
            wp.showCmd = SW_SHOWMINIMIZED;
            //Application->Minimize();
            }
        }
    else
        { // do not start minimized
        TrayPopupRestore->Visible = false;
        if (vs.maximized)
            wp.showCmd = SW_SHOWMAXIMIZED;
        }
    SetWindowPlacement(Handle, &wp);

    /*   */
    if ((vs.active_tab >= 0) && (vs.active_tab < PageControl1->PageCount))
        PageControl1->ActivePageIndex = vs.active_tab;

    f_first_run = 0;
    }

    /*    IP (IPaddr = auto|manual) */
    g_Conf.LoadIPCrates(IPCrateList);

    /*    g_Config */
    bool prio_high = (PriorityRank(g_Conf.ServerPriority()) > PRIORANK_NORMAL);
    TrayPopupHighPriority->Checked = prio_high;
    MenuSettingsHighPriority->Checked = prio_high;

    MenuSettingsMinimizeToTray->Checked = g_Conf.MinimizeToTray();
    MenuSettingsStartMinimized->Checked = g_Conf.StartMinimized();
    MenuSettingsAD_autoconnect->Checked = g_Conf.AutoConnectDynamic();
    MenuSettingsAD_enable->Checked = g_Conf.EnableAutoDiscovery();

    /*  auto-discovery ,     */
    MenuSettingsAD_autoconnect->Visible = g_Conf.AutoDiscoverySupport();
    MenuSettingsAD_enable->Visible = g_Conf.AutoDiscoverySupport();

    LogLevelMenuItemList[g_Conf.LogLevel()]->Checked = true;

    g_Log.OpenFile(g_Conf.LogFileName());
    g_Log.SetLevel(g_Conf.LogLevel());

    if (LangSel < sizeof(LangMenuItemList)/sizeof(LangMenuItemList[0]))
        LangMenuItemList[LangSel]->Checked = true;

    /*  file version info     caption */
    DWORD n = GetFileVersionInfoSize(Application->ExeName.c_str(), NULL);
    if (n)
        {
        AnsiString info[3] = {"ProductName", "ProductVersion", "CompanyName"};
        char *buf = new char[n];
        if (buf)
            {
            LPVOID val;
            UINT len;
            GetFileVersionInfo(Application->ExeName.c_str(), 0, n, buf);
            if (VerQueryValue(buf, "\\VarFileInfo\\Translation", &val, &len) && (len >= sizeof(DWORD)))
                {
                DWORD bestpage = MAKELONG(HIWORD(((LPDWORD)val)[0]), LOWORD(((LPDWORD)val)[0]));
                for (unsigned int i = 1; i < len / sizeof(DWORD); i++)
                    {
                    DWORD page = MAKELONG(HIWORD(((LPDWORD)val)[i]), LOWORD(((LPDWORD)val)[i]));
                    if (HIWORD(page) == GetLanguage())
                        {
                        bestpage = page;
                        break;
                        }
                    }
                AnsiString Prefix = "\\StringFileInfo\\" + IntToHex((int)bestpage, 8) + "\\";
                for (int i = 0; i < 3; i++)
                    {
                    if (VerQueryValue(buf, (Prefix + info[i]).c_str(), &val, &len))
                        info[i] = (LPTSTR)val;
                    }
                }
            delete[] buf;
            LOGWRITE("Starting up " + info[0] + " v" + info[1] + " (" + info[2] + ")",
                 LOGTASK_GLOBAL, LOGL_CRITICAL);
            Caption = info[0] + " v" + info[1];
            //      ( )
            unsigned int v[4] = { 0, 0, 0, 0 };
            sscanf(info[1].c_str(), "%3u.%3u.%3u.%3u", &v[0], &v[1], &v[2], &v[3]);
            g_ServerVersion = ((v[0] & 0xFF) << 24) | ((v[1] & 0xFF) << 16)
                            | ((v[2] & 0xFF) << 8) | (v[3] & 0xFF);
            }
        }


    { // Load icons
    const enum en_IconID icon_id[] = { icoNoCrates, icoCrateOk, icoCrateError };
    const char* const icon_name[] = { "icon_yellow", "icon_green", "icon_red" };
    HINSTANCE hInst = GetModuleHandle(NULL);
    for (int idx = 0; idx < sizeof(icon_id) / sizeof(icon_id[0]); idx++)
        {
        IconSet.AppIcon[icon_id[idx]] = LoadIcon(hInst, icon_name[idx]);
        IconSet.TrayIcon[icon_id[idx]] = LoadImage(hInst, icon_name[idx], IMAGE_ICON, 16, 16, 0);
        }
    IconSet.CurrentId = icoUndef; /* no icon loaded */
    }

    SetIcon(icoNoCrates);

    init_ok = false;
    ltrservicecrate = NULL;
    do  //   ,  do..while(0)      break
        {
        WSADATA wsaData;
        if (WSAStartup(0x0202, &wsaData) != 0)
            {
            LOGWRITE(Format("WSAStartup() error (%d)", ARRAYOFCONST(((int)WSAGetLastError()))),
                LOGTASK_GLOBAL, LOGL_CRITICAL);
            break;
            }
        if (wsaData.wVersion != 0x0202)
            {
            LOGWRITE("Invalid version of winsock dll, required 2.2",
                LOGTASK_GLOBAL, LOGL_CRITICAL);
            break;
            }
        ltrservicecrate = new TLTRServiceCrate(false, MQ_Display);
        if (!ltrservicecrate)
            {
            LOGWRITE("Cannot create LTRServiceCrate thread.", LOGTASK_GLOBAL, LOGL_CRITICAL);
            break;
            }
        if (WaitForSingleObject(ltrservicecrate->init_complete, 8000) == WAIT_OBJECT_0)
            {
            if (ltrservicecrate->init_ok)
                {
                UpdateInformationThread = new TUpdateInfoThread(this);
                }
            else
                {
                LOGWRITE("Initialization of LTRServiceCrate thread failed.", LOGTASK_GLOBAL, LOGL_CRITICAL);
                StopThread(ltrservicecrate);
                break;
                }
            }
        else
            {
            LOGWRITE("Cannot start LTRServiceCrate thread.", LOGTASK_GLOBAL, LOGL_CRITICAL);
            TerminateThread((HANDLE)ltrservicecrate->Handle, 0);
            break;
            }
        //   
        init_ok = true;
        }
    while (0); //   ,       break

    if (!init_ok)
        {
        //   
        int save_page = PageControl1->ActivePageIndex;
        //       
        g_Log.Flush(log_list->Lines, SCREEN_LOG_SIZE);
        //    
        PageControl1->ActivePageIndex = 2;
        Show();
        //     
        MessageBoxCtr(Handle, LoadStr(IDS_Failed_to_init) + g_Conf.LogFileName(),
            LoadStr(IDS_Error), MB_OK | MB_ICONERROR);
        //   ,      .ini
        PageControl1->ActivePageIndex = save_page;
        //     
        Close();
        Application->Terminate();
        return;
        }

#if USB_DETECT_ADVANCED
    DEV_BROADCAST_DEVICEINTERFACE NotifyFilter;
    ZeroMemory(&NotifyFilter, sizeof(NotifyFilter));
    NotifyFilter.dbcc_size = sizeof(NotifyFilter);
    NotifyFilter.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE;
    NotifyFilter.dbcc_classguid = USB_DEVICE_CLSID;
    hDevNotify =
        RegisterDeviceNotification(Handle, &NotifyFilter, DEVICE_NOTIFY_WINDOW_HANDLE);
#endif
    }
//---------------------------------------------------------------------------
void __fastcall TFormMAIN::FormClose(TObject *Sender, TCloseAction &Action)
    {
    LOGWRITE("Server shutting down", LOGTASK_GLOBAL, LOGL_CRITICAL);

    StopThread(UpdateInformationThread);

    StopThread(ltrservicecrate);

    CloseHandle(crate_list_access);
    CloseHandle(client_list_access);

    /*       */
    {
    WINDOWPLACEMENT wp;
    TLtrConfig::VisualState vs;
    wp.length = sizeof(wp);
    GetWindowPlacement(Handle, &wp);
    vs.rect = wp.rcNormalPosition;
    vs.maximized = (SW_SHOWMAXIMIZED == wp.showCmd);
    vs.active_tab = PageControl1->ActivePageIndex;
    g_Conf.SaveVisualState(vs);
    }

    /*      */
    g_Log.Flush(log_list->Lines, SCREEN_LOG_SIZE);
    g_Log.CloseFile();

    g_Conf.Close();

#if USB_DETECT_ADVANCED
    UnregisterDeviceNotification(hDevNotify);
#endif

    WSACleanup();

    Application->OnMinimize = NULL;
    Application->OnRestore = NULL;

    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::TrayIcon1Click(TObject *Sender)
    {
    if (Application && Application->MainForm)
        {
        Application->Restore();
        Application->MainForm->Visible = true;
        Application->ShowMainForm = true;
        ShowWindow(Application->Handle, SW_RESTORE);
        SetForegroundWindow(Application->Handle);
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::TrayIcon1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
    {
    if ((mbRight == Button) && Application && Application->MainForm)
        {
        TrayPopupMenu->Popup(X, Y);
        }
    }
//---------------------------------------------------------------------------
bool __fastcall TFormMAIN::ValidCell(int X, int Y)
    {
    TStringGrid *Grid = StringGridIPCrates;
    return (
           (X >= Grid->FixedCols)
        && (Y >= Grid->FixedRows)
        && (X < Grid->ColCount)
        && (Y < Grid->RowCount)
        && (Grid->Cells[EGRID_COL_IPADDR][Y] != "")
        );
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::Restart()
    {
    TCloseAction dummy;
    FormClose(this, dummy);
    FormCreate(this);
    }
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::GridContextPopup(TObject *Sender, TPoint &MousePos, bool &Handled)
    {
    TPoint PopupPos;
    TGridCoord cell;
    TStringGrid *Grid = StringGridIPCrates;

    PopupEditCrateIP->Visible = false;
    PopupDeleteCrateIP->Visible = false;
    PopupConnectCrate->Visible = false;
    PopupDisconnectCrate->Visible = false;
    PopupAutoConnectIPToggle->Visible = false;
    //PopupAddCrateIP->Visible = false;
    //PopupConnectAllIP->Visible = false;
    //PopupDisconnectAllIP->Visible = false;

    if ((MousePos.x >= 0) && (MousePos.y >= 0))
        { /* Popup  , MousePos =     */
        PopupPos = Grid->ClientToScreen(MousePos); /*      */
        cell = Grid->MouseCoord(MousePos.x, MousePos.y); /*      */
        //   
        if (ValidCell(cell.X, cell.Y))
            {
            Grid->Col = cell.X;
            Grid->Row = cell.Y;
            }
        }
    else
        { /* Popup   ([Menu]  [Shift-F10]) */
        cell.X = Grid->Col; /*   popup'  */
        cell.Y = Grid->Row; /*   ,   */
        TRect rect = Grid->CellRect(cell.X, cell.Y);
        /*         */
        PopupPos = Grid->ClientToScreen(TPoint(rect.left, rect.top));
        }

    if (ValidCell(cell.X, cell.Y))
        { /*        .
                  cell. */
        AnsiString IPString = Grid->Cells[EGRID_COL_IPADDR][cell.Y];
        AnsiString status = Grid->Cells[EGRID_COL_STATUS][cell.Y];
        if (status == SC_STAT_OFFLINE)
            { /* OFFLINE =>  ,    */
            PopupConnectCrate->Caption =
                AnsiReplaceStr(MenuCaption.Connect, "#IP#", IPString);
            PopupConnectCrate->Visible = true;

            PopupEditCrateIP->Caption =
                AnsiReplaceStr(MenuCaption.Edit, "#IP#", IPString);
            PopupEditCrateIP->Visible = true;

            PopupDeleteCrateIP->Caption =
                AnsiReplaceStr(MenuCaption.Delete, "#IP#", IPString);
            PopupDeleteCrateIP->Visible = true;
            }
        else if ((status == SC_STAT_ONLINE)
              || (status == SC_STAT_CONNECTING))
            { /* ONLINE, CONNECTING =>  .  . */
            PopupDisconnectCrate->Caption =
                AnsiReplaceStr(MenuCaption.Disconnect, "#IP#", IPString);
            PopupDisconnectCrate->Visible = true;
            }
        /*  toggle autoconnect */
        PopupAutoConnectIPToggle->Checked =
            (Grid->Cells[EGRID_COL_IPAUTO][cell.Y] == SC_AUTO_ON);
        PopupAutoConnectIPToggle->Caption =
            AnsiReplaceStr(MenuCaption.AutoConnect, "#IP#", IPString);
        PopupAutoConnectIPToggle->Visible = true;
        }

    GridPopupMenu->Popup(PopupPos.x, PopupPos.y);
    Handled = true;
    }
//---------------------------------------------------------------------------

int __fastcall TFormMAIN::GetPopupNode(TAddrListNode *pNode)
    {
    /*  PopupNode;    (IPLIST_...)  -1 */
    TGridCoord cell;
    TStringGrid *Grid = StringGridIPCrates;
    cell.X = Grid->Col; /*    */
    cell.Y = Grid->Row;
    if (!ValidCell(cell.X, cell.Y))
        return -1;
    /*  IP-  ,   PopupNode */
    return IPCrateList.Find(StrToIP(Grid->Cells[EGRID_COL_IPADDR][cell.Y]), pNode);
    }
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::PopupAddCrateIPClick(TObject *Sender)
    {
    FormAddIPDialog->IP_Addr = 0;
    if (!IsPositiveResult(FormAddIPDialog->ShowModal()))
        return;
    DWORD ip = FormAddIPDialog->IP_Addr;
    DWORD flags = FormAddIPDialog->IP_Flags;
    bool connect_now = FormAddIPDialog->CheckBoxConnectNow->Checked;

    if (g_Conf.AddIPCrate(IPCrateList, ip, flags, CFG_SAVE))
        {
        MQ_Display.put(LTR_DISP_ip_list_updated);
        if (connect_now && ltrservicecrate)
            ltrservicecrate->PostControlMessage(MsgControl(LTR_SRV_connect_crate, ip));
        }
    else
        {
        MessageBoxCtr(Handle, LoadStr(IDS_Bad_or_dup_address), LoadStr(IDS_Error),
            MB_OK | MB_ICONERROR);
        }
    }
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::PopupEditCrateIPClick(TObject *Sender)
    {
    TAddrListNode node;

    int list_idx = GetPopupNode(&node);

    //        
    if ((list_idx != IPLIST_STATIC) || (node.iStatus != IP_STATUS_OFFLINE))
        return;

    FormAddIPDialog->IP_Addr = node.dwIP;
    FormAddIPDialog->IP_Flags = node.dwFlags;
    FormAddIPDialog->CheckBoxConnectNow->Checked = false;
    if (!IsPositiveResult(FormAddIPDialog->ShowModal()))
        return;
    DWORD new_ip = FormAddIPDialog->IP_Addr;
    DWORD flags = FormAddIPDialog->IP_Flags;
    bool connect_now = FormAddIPDialog->CheckBoxConnectNow->Checked;

    if ((new_ip == node.dwIP) && (flags == node.dwFlags))
        return;

    if (g_Conf.ChangeIPCrate(IPCrateList, node.dwIP, new_ip, flags, CFG_SAVE))
        {
        MQ_Display.put(LTR_DISP_ip_list_updated);
        if (connect_now && ltrservicecrate)
            ltrservicecrate->PostControlMessage(MsgControl(LTR_SRV_connect_crate, new_ip));
        }
    else
        {
        MessageBoxCtr(Handle, LoadStr(IDS_Bad_or_dup_address), LoadStr(IDS_Error),
            MB_OK | MB_ICONERROR);
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupDeleteCrateIPClick(TObject *Sender)
    {
    TAddrListNode node;

    int list_idx = GetPopupNode(&node);
    if (list_idx < 0) return;

    //     
    if (node.iStatus != IP_STATUS_OFFLINE)
        return;

    AnsiString ip_str = IPToStr(node.dwIP);
    switch (list_idx)
        {
        case IPLIST_STATIC:
            if (MessageBoxCtr(Handle,
                LoadStr(IDS_Delete_address_) + ip_str + " ?",
                LoadStr(IDS_Are_you_sure), MB_OKCANCEL | MB_ICONQUESTION) == IDOK)
                {
                if (g_Conf.DeleteIPCrate(IPCrateList, node.dwIP, CFG_SAVE))
                    {
                    MQ_Display.put(LTR_DISP_ip_list_updated);
                    }
                else
                    {
                    MessageBoxCtr(Handle, LoadStr(IDS_Address_not_in_list),
                        LoadStr(IDS_Error), MB_OK | MB_ICONERROR);
                    }
                }
            break;
        case IPLIST_DYNAMIC:
            //         .ini   
            if (IPCrateList.Delete(IPLIST_DYNAMIC, node.dwIP))
                MQ_Display.put(LTR_DISP_ip_list_updated);
            break;
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupConnectCrateClick(TObject *Sender)
    {
    TAddrListNode node;
    if (GetPopupNode(&node) < 0) return;
    //     
    if (node.iStatus != IP_STATUS_OFFLINE)
        return;
    if (ltrservicecrate)
        ltrservicecrate->PostControlMessage(MsgControl(LTR_SRV_connect_crate, node.dwIP));
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupDisconnectCrateClick(TObject *Sender)
    {
    TAddrListNode node;
    if (GetPopupNode(&node) < 0) return;
    //      online  connecting
    if ((node.iStatus != IP_STATUS_ONLINE) && (node.iStatus != IP_STATUS_CONNECTING))
        return;
    if (ltrservicecrate)
        ltrservicecrate->PostControlMessage(MsgControl(LTR_SRV_disconnect_crate, node.dwIP));
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupConnectAllIPClick(TObject *Sender)
    {
    if (ltrservicecrate)
        ltrservicecrate->PostControlMessage(LTR_SRV_autoconnect_ip);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupDisconnectAllIPClick(TObject *Sender)
    {
    if (ltrservicecrate)
        ltrservicecrate->PostControlMessage(LTR_SRV_disconnect_all_ip);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::StringGridIPCratesDblClick(TObject *Sender)
    {
    TStringGrid* Grid = StringGridIPCrates;

    TPoint MousePos = Grid->ScreenToClient(Mouse->CursorPos);
    /*      */
    TGridCoord cell = Grid->MouseCoord(MousePos.x, MousePos.y);
    if (!ValidCell(cell.X, cell.Y))
        return;

    //   
    Grid->Col = cell.X;
    Grid->Row = cell.Y;

    AnsiString IPString = Grid->Cells[EGRID_COL_IPADDR][Grid->Row];
    DWORD ip = StrToIP(IPString);
    if (!ip) return;
    switch (Grid->Col)
        {
        case EGRID_COL_IPAUTO:
            // Doubleclick   "": / autoconnect
            {
            //bool is_static = (Grid->Cells[EGRID_COL_IPTYPE][Grid->Row] != SC_TYPE_DYNAMIC);
            bool NewAuto = (Grid->Cells[EGRID_COL_IPAUTO][Grid->Row] != SC_AUTO_ON);
            if (g_Conf.SetIPCrateFlags(IPCrateList, ip, CRATE_IP_FLAG_AUTOCONNECT,
                (NewAuto ? CRATE_IP_FLAG_AUTOCONNECT : 0), CFG_SAVE))
                {
                MQ_Display.put(LTR_DISP_ip_list_updated);
                }
            }
            break;
        case EGRID_COL_STATUS:
            // Doubleclick   "": /
            if (ltrservicecrate)
                {
                AnsiString status = Grid->Cells[EGRID_COL_STATUS][Grid->Row];
                if (status == SC_STAT_OFFLINE)
                    {
                    ltrservicecrate->PostControlMessage(MsgControl(LTR_SRV_connect_crate, ip));
                    }
                else if ((status == SC_STAT_ONLINE)
                      || (status == SC_STAT_CONNECTING))
                    {
                    ltrservicecrate->PostControlMessage(MsgControl(LTR_SRV_disconnect_crate, ip));
                    }
                }
            break;
        /*
        case EGRID_COL_IPADDR:
            // Doubleclick   "":  IP
            PopupEditCrateIPClick(Sender);
            break;
        */
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::StringGridIPCratesMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
    {
    static int lastrow = -1, lastcol = -1;
    int row, col;

    /*  tooltip' */
    TStringGrid *Grid = StringGridIPCrates;
    Grid->MouseToCell(X, Y, col, row);
    if ((col != lastcol) || (row != lastrow))
        {
        lastcol = col;
        lastrow = row;
        AnsiString hint = "";
        if (ValidCell(col, row))
            {
            switch (col)
                {
                case EGRID_COL_IPAUTO:
                    hint = SC_Tooltip_Auto;
                    break;
                case EGRID_COL_IPTYPE:
                    hint = SC_Tooltip_Type[(Grid->Cells[col][row] == SC_TYPE_DYNAMIC)];
                    break;
                case EGRID_COL_STATUS:
                    hint = SC_Tooltip_Status;
                    break;
                }
            }
        Application->CancelHint();
        Grid->Hint = hint;
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupAutoConnectIPToggleClick(TObject *Sender)
    {
    TAddrListNode node;
    int list_idx = GetPopupNode(&node);
    if (list_idx < 0) return;
    node.dwFlags ^= CRATE_IP_FLAG_AUTOCONNECT;
    if (g_Conf.SetIPCrateFlags(IPCrateList, node.dwIP, CRATE_IP_FLAG_AUTOCONNECT,
        node.dwFlags, CFG_SAVE))
        {
        MQ_Display.put(LTR_DISP_ip_list_updated);
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PageControl1Resize(TObject *Sender)
    {
    /*     IPGridColWidth    1000 */
    /*  0  " " */

    int NumCols = std::min<int>(StringGridIPCrates->ColCount,
        sizeof(IPGridColWidth)/sizeof(IPGridColWidth[0]));
    int Space = StringGridIPCrates->Width;
    int Sep = StringGridIPCrates->GridLineWidth + 1;
    double K = Space / 1000.0;
    for (int i = 0; i < NumCols; i++)
        {
        if (IPGridColWidth[i] == 0)
            {
            StringGridIPCrates->ColWidths[i] = Space;
            break;
            }
        int cw = K * IPGridColWidth[i];
        StringGridIPCrates->ColWidths[i] = cw;
        Space -= (cw + Sep);
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuFileRestartClick(TObject *Sender)
    {
    Restart();
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuFileExitClick(TObject *Sender)
    {
    Close();
    }
//---------------------------------------------------------------------------


void __fastcall TFormMAIN::MenuLogLevelClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    for (int i = 0; i < sizeof(LogLevelMenuItemList)/sizeof(LogLevelMenuItemList[0]); i++)
        {
        if (LogLevelMenuItemList[i] == self)
            {
            g_Conf.LogLevel(i, CFG_SAVE);
            g_Log.SetLevel(g_Conf.LogLevel());
            break;
            }
        }
    self->Checked = true;
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuSettingsLangClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    //    ,   
    if (self->Checked) return;

    self->Checked = true;
    for (int i = 0; i < sizeof(LangMenuItemList)/sizeof(LangMenuItemList[0]); i++)
        {
        if (LangMenuItemList[i] == self)
            {
            if (i < sizeof(LanguageInfo)/sizeof(LanguageInfo[0]))
                {
                LANGID savelang = GetLanguage();
                g_Conf.Language(LanguageInfo[i].ConfigStr, CFG_SAVE);
                //   ,  messagebox    
                SetLanguage(LanguageInfo[i].langid);
                if (MessageBoxCtr(Handle,
                    LoadStr(IDS_RestartToApply), LoadStr(IDS_LangChange),
                    MB_OKCANCEL | MB_ICONQUESTION) == IDOK)
                    {
                    Restart();
                    }
                else
                    {
                    SetLanguage(savelang);
                    }
                }
            break;
            }
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuSettingsHighPriorityClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    bool set_high = !self->Checked;
    //    ,    callback
    MenuSettingsHighPriority->Checked = set_high;
    TrayPopupHighPriority->Checked = set_high;
    g_Conf.ServerPriority(set_high ? HIGH_PRIORITY_CLASS : NORMAL_PRIORITY_CLASS,
        CFG_SAVE);
    if (ltrservicecrate)
        ltrservicecrate->PostControlMessage(LTR_SRV_server_priority_changed);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuSettingsStartMinimizedClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    g_Conf.StartMinimized(self->Checked, CFG_SAVE);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuSettingsMinimizeToTrayClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    g_Conf.MinimizeToTray(self->Checked, CFG_SAVE);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuSettingsAD_autoconnectClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    g_Conf.AutoConnectDynamic(self->Checked, CFG_SAVE);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuSettingsAD_enableClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    if (g_Conf.EnableAutoDiscovery(self->Checked, CFG_SAVE) != self->Checked)
        { //   
        if (ltrservicecrate)
            ltrservicecrate->PostControlMessage(LTR_SRV_autodiscovery_changed);
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::LogPopupClearClick(TObject *Sender)
    {
    log_list->Clear();
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::StringGridIPCratesKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
    {
    /* /   [Ctrl-Enter] */
    if ((Shift == (TShiftState() << ssCtrl)) && (Key == VK_RETURN) && ltrservicecrate)
        {
        TAddrListNode node;
        if (GetPopupNode(&node) < 0) return;
        switch (node.iStatus)
            {
            case IP_STATUS_OFFLINE:
                ltrservicecrate->PostControlMessage(MsgControl(LTR_SRV_connect_crate, node.dwIP));
                break;
            case IP_STATUS_ONLINE:
            case IP_STATUS_CONNECTING:
                ltrservicecrate->PostControlMessage(MsgControl(LTR_SRV_disconnect_crate, node.dwIP));
                break;
            }
        }
    }
//---------------------------------------------------------------------------

