#ifndef CriticalH
#define CriticalH

#include <windows.h>

/*================================================================================================*
 *      .
 * TCritical: /  .
 * TCSLock:       .
 *  :
 * class TMyClass
 *     {
 *     TCritical cs;
 *     int DoExclusive(void)
 *         { TCSLock lock(cs); ... return 1; }
 *     };
 *================================================================================================*/
class TCritical
    {
private:
    CRITICAL_SECTION critical_section;
public:
    TCritical()
        { InitializeCriticalSectionAndSpinCount(&critical_section, 0x80000400); }
    ~TCritical()
        { DeleteCriticalSection(&critical_section); }
    void Enter()
        { EnterCriticalSection(&critical_section); }
    void Leave()
        { LeaveCriticalSection(&critical_section); }
    };

class TCSLock
    {
private:
    TCritical &cs_object;
public:
    TCSLock(TCritical &critical)
        : cs_object(critical)
        { cs_object.Enter(); }
     ~TCSLock()
        { cs_object.Leave(); }
    };
/*================================================================================================*/
#endif
