#ifndef usb_utilH
#define usb_utilH

#include <windows.h>
#pragma pack(push, 1)
#include <setupapi.h>
#pragma pack(pop)
#include <classes.hpp>

/*================================================================================================*/
enum en_USB_Speed
    {
    USB_Speed_Unknown = -1,
    USB_Speed_Low = 0,
    USB_Speed_Full = 1,
    USB_Speed_High = 2,
    };

struct t_USB_ConnInfo
    {
    USHORT usb_version;         //  bcdUSB   (0x0110, 0x0200)
    enum en_USB_Speed speed;    //  
    t_USB_ConnInfo() : usb_version(0), speed(USB_Speed_Unknown) { }
    };
/*================================================================================================*/

/*================================================================================================*/
extern const CLSID USB_DEVICE_CLSID;
extern const CLSID USB_HUB_CLSID;
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
bool USB_GetDeviceInfoByInstance
    (
    DWORD DevInst,                          // ()    (DEVINST)
    AnsiString* pstrDevicePath,             // ()    CreateFile() ( NULL)
    t_USB_ConnInfo* pConnInfo,              // ()    USB ( NULL)
    AnsiString& strErrorMsg                 // ()   ,    false
    );
/*------------------------------------------------------------------------------------------------*/
bool USB_GetDeviceInfoByIface
    (
    HDEVINFO hList,                         // ()    
    PSP_DEVICE_INTERFACE_DATA pIfaceData,   // ()     hList
    AnsiString* pstrDevicePath,             // ()    CreateFile() ( NULL)
    AnsiString* pstrDescription,            // ()  ( NULL)
    DWORD* pDevInst,                        // ()   DEVINST ( NULL)
    AnsiString& strErrorMsg                 // ()   ,    false
    );
/*------------------------------------------------------------------------------------------------*/
bool USB_GetDeviceInfoByPath
    (
    const char* szPath,                     // ()    
    AnsiString* pstrDescription,            // ()  ( NULL)
    DWORD* pDevInst,                        // ()   DEVINST ( NULL)
    AnsiString& strErrorMsg                 // ()   ,    false
    );
/*------------------------------------------------------------------------------------------------*/
bool USB_IsKnownDeviceName(const AnsiString& strDevicePath);
/*------------------------------------------------------------------------------------------------*/
AnsiString USB_ConnInfoString(const t_USB_ConnInfo& info);
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
#endif
